﻿using System;
using System.Collections.Generic;
using Layer2.SharePoint.UI.Administration.Lists;
using Microsoft.SharePoint;

namespace Layer2.Products.BdlcApiExamples
{
    internal class DisableBdlc
    {
        internal static void DisableBdlcInThisSite(SPWeb currentWeb)
        {
            SPList configurationList = BdlcConfigList.GetList(currentWeb);
            List<int> listIdsToDelete = new List<int>();

            foreach (SPListItem item in configurationList.Items)
            {
                if (currentWeb.ID != new Guid(item[Constants.WEB_ID].ToString()))
                    return;
                // each list in the current web should be cleaned of the BDLC event receivers attached
                DisableListEvents(currentWeb, item);

                // mark item for delete 
                listIdsToDelete.Add(item.ID);
            }

            foreach (int i in listIdsToDelete)
            {
                configurationList.GetItemById(i).Delete();
            }
        }

        internal static void DisableBdlcInThisList(SPList list)
        {
            DisableListEvents(list);
            SPList configurationList = BdlcConfigList.GetList(list.ParentWeb);
            SPListItem configItem = CheckIfListsExistsInConfigList.GetConfigItem(configurationList, list);
            configurationList.GetItemById(configItem.ID).Delete();
        }
        
        private static void DisableListEvents(SPWeb web, SPListItem configListItem)
        {
            SPList bdlcList = web.Lists[new Guid(configListItem[Constants.LIST_ID].ToString())];
            DisableListEvents(bdlcList);
        }
        private static void DisableListEvents(SPList list)
        {
            var logic = new BusinessDataListConnectorLogic();
            logic.Init(list);
            logic.EnableOrDisableListEvents(false);
        }
    }
}
